
#ifndef __GTK_CELL_RENDERER_BUTTON_H__
#define __GTK_CELL_RENDERER_BUTTON_H__

#include <gtk/gtkcellrenderer.h>
#include <gtk/gtkbutton.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define GTK_TYPE_CELL_RENDERER_BUTTON			(gtk_cell_renderer_button_get_type ())
#define GTK_CELL_RENDERER_BUTTON(obj)			(GTK_CHECK_CAST ((obj), GTK_TYPE_CELL_RENDERER_BUTTON, GtkCellRendererButton))
#define GTK_CELL_RENDERER_BUTTON_CLASS(klass)		(GTK_CHECK_CLASS_CAST ((klass), GTK_TYPE_CELL_RENDERER_BUTTON, GtkCellRendererButtonClass))
#define GTK_IS_CELL_RENDERER_BUTTON(obj)		(GTK_CHECK_TYPE ((obj), GTK_TYPE_CELL_RENDERER_BUTTON))
#define GTK_IS_CELL_RENDERER_BUTTON_CLASS(klass)	(GTK_CHECK_CLASS_TYPE ((klass), GTK_TYPE_CELL_RENDERER_BUTTON))
#define GTK_CELL_RENDERER_BUTTON_GET_CLASS(obj)         (GTK_CHECK_GET_CLASS ((obj), GTK_TYPE_CELL_RENDERER_BUTTON, GtkCellRendererButtonClass))

typedef struct _GtkCellRendererButton GtkCellRendererButton;
typedef struct _GtkCellRendererButtonClass GtkCellRendererButtonClass;

struct _GtkCellRendererButton
{
    GtkCellRenderer parent;

    /*< private >*/
    gpointer button;
    guint activatable : 1;
};

struct _GtkCellRendererButtonClass
{
    GtkCellRendererClass parent_class;

    void (* clicked) (GtkCellRendererButton *cell_renderer_button,
                      const gchar           *path);

    /* Padding for future expansion */
    void (*_gtk_reserved1) (void);
    void (*_gtk_reserved2) (void);
    void (*_gtk_reserved3) (void);
    void (*_gtk_reserved4) (void);
};

GtkType          gtk_cell_renderer_button_get_type  (void);
GtkCellRenderer* gtk_cell_renderer_button_new       (void);

gpointer         gtk_cell_renderer_button_get_button (GtkCellRendererButton *button);
void             gtk_cell_renderer_button_set_button (GtkCellRendererButton *button,
                                                      gpointer               widget);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __GTK_CELL_RENDERER_BUTTON_H__ */
