#ifndef _GTKMM_CELLRENDERERBUTTON_H
#define _GTKMM_CELLRENDERERBUTTON_H

#include <glibmm.h>
#include <gtkmm/cellrenderer.h>
#include <gtkmm/button.h>
#include <gtk/gtkbutton.h>
#include <myrenderer_p.h>

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkCellRendererButton GtkCellRendererButton;
typedef struct _GtkCellRendererButtonClass GtkCellRendererButtonClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class CellRendererButton_Class; } // namespace Gtk
namespace Gtk
{

class CellRendererButton : public CellRenderer
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef CellRendererButton CppObjectType;
  typedef CellRendererButton_Class CppClassType;
  typedef GtkCellRendererButton BaseObjectType;
  typedef GtkCellRendererButtonClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~CellRendererButton();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class CellRendererButton_Class;
  static CppClassType cellrendererbutton_class_;

  CellRendererButton(const CellRendererButton&);
  CellRendererButton& operator=(const CellRendererButton&); // not implemented

protected:
  explicit CellRendererButton(GtkCellRendererButton* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkCellRendererButton* gobj()             { return (GtkCellRendererButton*)(gobject_); }
  const GtkCellRendererButton* gobj() const { return (GtkCellRendererButton*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_clicked(const Glib::ustring& path);


private:

public:

  CellRendererButton();

  gpointer get_button();

  void set_button(gpointer     button);
  void set_button(GtkButton   *button);
  void set_button(Gtk::Button *button);

  Glib::SignalProxy1<void,const Glib::ustring&> signal_clicked();

  Glib::PropertyProxy<bool> property_activatable();

  Glib::PropertyProxy< gpointer > property_button();

  virtual Glib::PropertyProxy_Base _property_renderable(); //override

};

} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::CellRendererButton */
  Gtk::CellRendererButton* wrap(GtkCellRendererButton* object, bool take_copy = false);
}
#endif /* _GTKMM_CELLRENDERERBUTTON_H */

